/*
 * Test1.xc

 *
 *  Created on: Jan 11, 2018
 *      Author: Larry
 */
#include <xs1.h>
#include <platform.h>
#include <stdio.h>
#include "../../lib_gpio/api/gpio.h"
#include "../../lib_uart/api/uart.h"
//#include <debug_print.h>

//#include "efm32gg_uart.h"
#include "xs1.h"

// Port declarations
port p_uart_rx = on tile[0] : XS1_PORT_1A;
port p_uart_tx = on tile[0] : XS1_PORT_1B;
#define RX_BUFFER_SIZE 20

void app(client uart_tx_if uart_tx,
        client uart_rx_if uart_rx)
{
    // Write a byte to the UART
    uart_tx.write(0xff);
    // Wait for a byte to
    select
    {
    case uart_rx.data_ready():
        uint8_t data = uart_rx.read();
        printf("Data received %d\n", data);
        break;
    }
}

int main()
{
    interface uart_rx_if i_rx;
    interface uart_tx_if i_tx;
    input_gpio_if i_gpio_rx[1];
    output_gpio_if i_gpio_tx[1];
    par
    {
        on tile[0]: output_gpio(i_gpio_tx, 1, p_uart_tx, null);
        on tile[0]: uart_tx(i_tx, null,
                115200, UART_PARITY_NONE, 8, 1,
                i_gpio_tx[0]);
        on tile[0].core[0] : input_gpio_with_events(i_gpio_rx, 1, p_uart_rx, null);
        on tile[0].core[0] : uart_rx(i_rx, null, RX_BUFFER_SIZE,
                115200, UART_PARITY_NONE, 8, 1,
                i_gpio_rx[0]);
        on tile[0]: app(i_tx, i_rx);
    }
    return 0;
}
